<?php

namespace STM\Competition\Playoff;

use \GetterOfTestingInstances;

/**
 * Test class for PlayoffValidator.
 * Generated by PHPUnit on 2012-02-02 at 20:42:22.
 * @group competition_playoff
 */
class PlayoffValidatorTest extends \PHPUnit_Framework_TestCase {

    protected function setUp() {
        PlayoffValidator::init();
    }

    public function testCheck_create() {
        // must be <1, 50>
        parent::assertTrue(PlayoffValidator::checkCreate(array('serie_win_matches' => 1)));
        parent::assertTrue(PlayoffValidator::checkCreate(array('serie_win_matches' => 50)));
        // array with key serie_win_matches
        $this->assert_bad_arguments_for_create(null);
        $this->assert_bad_arguments_for_create(array('serie_win' => 50));
        $this->assert_bad_arguments_for_create(array('serie_win_matches' => 0));
        $this->assert_bad_arguments_for_create(array('serie_win_matches' => 50, 'whatever' => 'Hello'));
    }

    public function testCheckSerieWinMatches() {
        for ($i = 1; $i <= 50; $i += 5) {
            parent::assertTrue(PlayoffValidator::checkSerieWinMatches($i));
        }
        $this->assert_bad_arguments_for_serie_win(-1);
        $this->assert_bad_arguments_for_serie_win(51);
        $this->assert_bad_arguments_for_serie_win(null);
        $this->assert_bad_arguments_for_serie_win(array());
        
        foreach (GetterOfTestingInstances::find_playoffs() as $playoff) {
            PlayoffValidator::setPlayoff($playoff);
            parent::assertFalse(PlayoffValidator::checkSerieWinMatches($playoff->getSerieWinMatches()));
            PlayoffValidator::init();
        }
    }
    
    private function assert_bad_arguments_for_create($attributes) {
        $this->assert_bad_arguments($attributes, 'checkCreate');
    }
    
    private function assert_bad_arguments_for_serie_win($serie_win_matches) {
        $this->assert_bad_arguments($serie_win_matches, 'checkSerieWinMatches');
    }
    
    private function assert_bad_arguments($data, $method) {
        PlayoffValidator::init();
        parent::assertFalse(PlayoffValidator::$method($data));
        PlayoffValidator::init();
    }

}

?>
